unit MySqlDSReg;
{
  MySQL Native Delphi DataSet (c)2003 by Paul TOTH <tothpaul@free.fr>
  http://tothpaul.free.fr
}

{

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

}

interface

uses
 Classes, MySQLDS, DesignIntf, DesignEditors;

procedure Register;

implementation

{$R *.DCR}

type
 TMySQLListProperty = class(TStringProperty)
 public
  function GetAttributes: TPropertyAttributes; override;
  procedure GetValues(Proc: TGetStrProc); override;
  procedure GetValueList(List: TStrings); virtual; abstract;
 end;

 TMySQLDatabaseProperty=class(TMySQLListProperty)
  procedure GetValueList(List: TStrings); override;
 end;

 TMySQLTableNameProperty=class(TMySQLListProperty)
  procedure GetValueList(List: TStrings); override;
 end;

procedure Register;
begin
 RegisterComponents('MySoft.SQL',[TMySQLConnection,TMySQLDataSet]);
 RegisterPropertyEditor(TypeInfo(string), TMySQLConnection, 'Database',  TMySQLDatabaseProperty);
 RegisterPropertyEditor(TypeInfo(string), TMySQLDataSet, 'TableName', TMySQLTableNameProperty);
end;

{ TMySqlListProperty }

function TMySqlListProperty.GetAttributes: TPropertyAttributes;
begin
 Result := [paValueList, paSortList, paMultiSelect];
end;

procedure TMySqlListProperty.GetValues(Proc: TGetStrProc);
var
 List:TStrings;
 i:integer;
begin
 List:=TStringList.Create;
 try
  GetValueList(List);
  for i:=0 to List.Count-1 do Proc(List[i]);
 finally
  List.Free;
 end;
end;

{ TMySQLDatabaseProperty }

procedure TMySQLDatabaseProperty.GetValueList(List: TStrings);
var
 CN:TMySQLConnection;
begin
 CN:=GetComponent(0) as TMySQLConnection;
 if CN=nil then exit;
 CN.ShowQuery('SHOW DATABASES',List);
end;

{ TMySQLTableNameProperty }

procedure TMySQLTableNameProperty.GetValueList(List: TStrings);
var
 DS:TMySQLDataSet;
 CN:TMySQLConnection;
begin
 DS:=GetComponent(0) as TMySQLDataSet;
 CN:=DS.Connection;
 if CN=nil then exit;
 if CN.Database='' then exit;
 CN.ShowQuery('SHOW TABLES ',List);
end;

end.
